Support for Java 7 and above.